# TODO: move path to ezmlm to a constant
#	more functions!
#	make a meaningful index_html?

from OFS.SimpleItem import Item
from Globals import Persistent, HTMLFile
from Acquisition import Implicit

manage_addEzmlmForm = HTMLFile('DTML/manage_addEzmlmForm', globals())

def manage_addEzmlm(self, id, REQUEST):
  "Method for adding an Ezmlm object"
  newEzmlm = ezmlmClass(id)
  self._setObject(id, newEzmlm)
  return self.manage_main(self, REQUEST)

class ezmlmClass(Item, Persistent, Implicit):
  def __init__(self, id, title='', List='/home/admin/list', listemail='list@server.com'):
    self.id = id
    self.title = title
    self.List = List 
    self.listemail = listemail

  meta_type = "Ezmlm object"

  _properties = (
    {'id':'title', 'type':'string', 'mode':'w'},
    )

  manage_options = ({'label':'Edit','action':'manage_editEzmlmForm'},
			{'label':'List','action':'manage_list'},
			{'label':'Undo','action':'manage_UndoForm'},
			{'label':'Ownership','action':'manage_owner'}
		)

  def edit(self, title, List, listemail, REQUEST=None):
    "method to edit Ezmlm instances"
    self.title = title
    self.List = List
    self.listemail = listemail
    if REQUEST is not None:
      return self.manage_editEzmlmForm(self, REQUEST)

  def list(self):
    "method to retrieve Ezmlm list"
    import commands
    return commands.getoutput('/usr/local/bin/ezmlm/ezmlm-list ' + self.List)

  def sub(self, email, REQUEST=None):
    "method to add subscriber to a list"
    import commands
    if email is not None:
      (intStatus, strOutput) = commands.getstatusoutput('/usr/local/bin/ezmlm/ezmlm-sub ' + self.List + ' ' + email)
      if intStatus == 0:
        return self.index_html(self,REQUEST)
      else:
        return 'Status= %d, Output= %s' % (intStatus, strOutput)
    if REQUEST is not None:
        try:    url=dispatcher.DestinationURL()
        except: url=REQUEST['URL1']
        REQUEST['RESPONSE'].redirect('%s/index_html' % url)
#    return self.index_html(self,REQUEST)

  def unsub(self, email, REQUEST=None):
    "method to remove a subscriber from a list"
    import commands
    if email is not None:
      (intStatus, strOutput) = commands.getstatusoutput('/usr/local/bin/ezmlm/ezmlm-unsub ' + self.List + ' ' + email)
      if intStatus == 0:
        return self.index_html(self,REQUEST)
      else:
        return 'Status= %d, Output= %s' % (intStatus, strOutput)
    if REQUEST is not None:
        try:    url=dispatcher.DestinationURL()
        except: url=REQUEST['URL1']
        REQUEST['RESPONSE'].redirect('%s/index_html' % url)
#    return self.index_html(self,REQUEST)

  def check(self, email, REQUEST=None):
    "method to check if a subscriber is in a list"
    import commands, string
    if email is not None:
      strList = commands.getoutput('/usr/local/bin/ezmlm/ezmlm-list ' + self.List)
      subList = string.split(strList)
      for subscriber in subList:
        if subscriber == email:
          return 1
    return 0

  # Web Methods
  manage_list = HTMLFile('DTML/manage_list', globals())
  subscribe = HTMLFile('DTML/subscribe', globals())
  manage_editEzmlmForm = HTMLFile('DTML/manage_editEzmlmForm', globals())
